package de.ozgcloud.nachrichten;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import de.ozgcloud.apilib.common.command.OzgCloudCommandService;
import de.ozgcloud.apilib.common.command.grpc.CommandMapper;
import de.ozgcloud.apilib.common.command.grpc.GrpcOzgCloudCommandService;
import de.ozgcloud.vorgang.grpc.command.CommandServiceGrpc;
import net.devh.boot.grpc.client.inject.GrpcClient;

@Configuration
public class NachrichtenManagerConfiguration {

	public static final String OZG_CLOUD_COMMAND_SERVICE_NAME = "nachrichten_OzgCloudCommandService";

	public static final String NACHRICHTEN_VORGANG_SERVICE = "nachrichten_vorgangService";
	public static final String NACHRICHTEN_VORGANG_REMOTE_SERVICE = "nachrichten_vorgangRemoteService";

	public static final String GRPC_VORGANG_MANAGER_NAME = "vorgang-manager";
	public static final String GRPC_COMMAND_MANAGER_NAME = "command-manager";

	@GrpcClient(GRPC_COMMAND_MANAGER_NAME)
	private CommandServiceGrpc.CommandServiceBlockingStub commandServiceStub;

	@Bean(OZG_CLOUD_COMMAND_SERVICE_NAME)
	OzgCloudCommandService grpcOzgCloudCommandService(CommandMapper commandMapper, NachrichtenManagerCallContextProvider contextProvider) {
		return new GrpcOzgCloudCommandService(commandServiceStub, commandMapper, contextProvider,
				GrpcOzgCloudCommandService.DEFAULT_COMMAND_REQUEST_THRESHOLD_MILLIS);
	}
}