package de.ozgcloud.nachrichten.antragraum;

import java.util.Arrays;

import lombok.Getter;

@Getter
enum TrustLevel {

	LEVEL_1("STORK-QAA-Level-1"),
	LEVEL_2("STORK-QAA-Level-2"),
	LEVEL_3("STORK-QAA-Level-3"),
	LEVEL_4("STORK-QAA-Level-4");

	private final String value;
	private final int intValue;

	TrustLevel(String value) {
		this.value = value;
		this.intValue = extractIntValue();
	}

	private int extractIntValue() {
		return Integer.parseInt(value.substring(value.length() - 1));
	}

	public static TrustLevel fromString(String value) {
		return Arrays.stream(TrustLevel.values()).filter(trustLevel -> trustLevel.getValue().equals(value)).findFirst()
				.orElseThrow(() -> new IllegalArgumentException("Unknown TrustLevel: '" + value + "'"));
	}
}